function modeloDocumentoFiscal() {
    const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
    const z = new ZeedhiAPIConstructor(browser, protractor);
    const Helper = require('teknisa-helper');
    const geralPage = new Helper.geral();
    const protractorHelper = require('protractor-helper');
    this.abrir = () => {
        z.component.menu.open();
        protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
        z.component.menu.clickByPath(['Parametrização', 'Documentos Fiscais', 'Modelo de Documento Fiscal']);
        geralPage.esperarLoading();
    };

    this.adicionarModeloDocumento = (cdmoddocfisc, dsmoddocfisc, idmoddocnfes) => {
        geralPage.fillField('CDMODDOCFISC', cdmoddocfisc);
        geralPage.fillField('DSMODDOCFISC', dsmoddocfisc);
        geralPage.selectNative('IDMODDOCNFE', idmoddocnfes);
    };

    this.editarModeloDocumento = (dsmoddocfisc, idmoddocnfes) => {
        geralPage.fillField('DSMODDOCFISC', dsmoddocfisc);
        geralPage.selectNative('IDMODDOCNFE', idmoddocnfes);
    };

    this.excluirModeloDocumento = () => {
        geralPage.clickExcluir();
        geralPage.clickSim();
    };

    this.adicionarModeloDocOper = (identrsaidop, nmtipooper, dsmoddocfisc) => {
        element.all(by.id('IDENTRSAIDOP')).then(function(arr) {
            protractorHelper.click(arr[1].element(by.xpath('..'))
                .element(by.css('div.new-select')));
            const opcoes = element.all(by.css('div.new-select.open > ul > li.option'));
            opcoes.each((item) => {
                item.getText()
                    .then((valor) => {
                        if (valor == identrsaidop) {
                            protractorHelper.click(item);
                        }
                    })
                    .catch((erro) => console.log('Erro: ' + erro));
            });
        });
        element.all(by.css('#NMTIPOOPER .zh-icon-search')).then(function(arr) {
            protractorHelper.click(arr[1]);
        });
        geralPage.searchTextOnFloating(nmtipooper);
        geralPage.clickGrid('NMTIPOOPER', nmtipooper, '9000', true);
        geralPage.searchAndClickGridField('DSMODDOCFISC', dsmoddocfisc, 'DSMODDOCFISC');
    };

    this.excluirModeloDocOper = (identrsaidop, nmtipooper) => {
        geralPage.selectNative('IDENTRSAIDOP', identrsaidop);
        geralPage.searchAndClickGridField('NMTIPOOPER', nmtipooper, 'NMTIPOOPER');
    };
}
module.exports = new modeloDocumentoFiscal();
